## syfi 0.6.1.dfsg

=== SConstruct ===
# -*- coding: utf-8 -*-

import os, os.path, sys
from os.path import join as pjoin

# Make sure that we have a good scons-version
EnsureSConsVersion(0, 96)

# Import the local 'scons'
# Add simula-scons to sys.path and PYTHONPATH
os.environ["PYTHONPATH"] = \
    os.pathsep.join([os.environ.get("PYTHONPATH",""),
                     pjoin(os.getcwd(), "scons", "simula-scons")])
sys.path.insert(0, pjoin(os.getcwd(), "scons", "simula-scons"))
import simula_scons as scons
 
# Import local exceptions
from simula_scons.Errors import PkgconfigError, PkgconfigMissing

# Create a SCons Environment based on the main os environment
env = scons.ExtendedEnvironment(ENV=os.environ)

# Set a projectname. Used in some places, like pkg-config generator
env["projectname"] = "syfi"

# Set version
env["SYFILIB_VERSION"] = "0.6.1"

def replace_lines(dotin_fname, replacements):
    f = file(dotin_fname)
    lines = f.readlines()
    f.close()

    for item in replacements:
        # find line(s) in body that match the substitution key:
        repl_lines = [l for l in lines if "@"+item+"@" in l]
        # replace the key with the replacements item, and feed into the body
        # We support multiple occurences of a string, although that should be 
        # rare:
        for l in repl_lines:
            lines[lines.index(l)] = l.replace("@"+item+"@", replacements[item])

    f = file(dotin_fname[:-3], 'w')
    f.writelines(lines)
    f.close()

replacements = {'SYFILIB_VERSION': env['SYFILIB_VERSION']}
replace_lines(pjoin('syfi', 'scons.cfg.in'), replacements)

major, minor, micro = env["SYFILIB_VERSION"].split('.')
replacements = {'SYFILIB_MAJOR_VERSION': major,
                'SYFILIB_MINOR_VERSION': minor,
                'SYFILIB_MICRO_VERSION': micro}
replace_lines(pjoin('syfi', 'syfi_version.h.in'), replacements)

try:
    out, err = scons.runCommand("pkg-config", ["ginac", "--modversion"])
except:
    print "Unable to get ginac version"
    # this will fail later
    out = "1.4.1"
major, minor, micro = out.split('.')
replacements = {'GINACLIB_MAJOR_VERSION': major,
                'GINACLIB_MINOR_VERSION': minor,
                'GINACLIB_MICRO_VERSION': micro}
replace_lines(pjoin('syfi', 'swig', 'SyFi.i.in'), replacements)


scons.setDefaultEnv(env)

# Specify a file where SCons store file signatures, used to figure out what is
# changed. We store it in the 'scons' subdirectory to avoid mixing signatures
# with the files in SyFi. 
syfi_sconsignfile = pjoin(os.getcwd(), "scons", ".sconsign")
env.SConsignFile(syfi_sconsignfile)

# -----------------------------------------------------------------------------
# Command line option handling
# -----------------------------------------------------------------------------

DefaultPackages = ""

default_prefix = pjoin(os.path.sep, "usr", "local")

# Build the commandline options for SCons:
options = [
    # configurable options for installation:
    scons.PathOption("prefix", "Installation prefix", default_prefix),
    scons.PathOption("DESTDIR",
                     "Prepend DESTDIR to each installed target file", None),
    scons.PathOption("binDir", "Binary installation directory",
                     pjoin("$prefix", "bin")),
    scons.PathOption("manDir", "Manual page installation directory",
                     os.path.join("$prefix", "share", "man")),
    scons.PathOption("libDir", "Library installation directory",
                     pjoin("$prefix", "lib")),
    scons.PathOption("pkgConfDir", "Directory for installation of pkg-config files",
                     pjoin("$prefix", "lib", "pkgconfig")),
    scons.PathOption("includeDir", "C/C++ header installation directory",
                     pjoin("$prefix", "include")),
    scons.PathOption("pythonModuleDir", "Python module installation directory", 
                     scons.defaultPythonLib(prefix="$prefix")),
    scons.PathOption("pythonExtDir", "Python extension module installation directory", 
                     scons.defaultPythonLib(prefix="$prefix", plat_specific=True)),
    # configurable options for how we want to build:
    BoolOption("enableDebug", "Build with debug information", 1),
    BoolOption("enableDebugUblas", "Add some extra Ublas debug information", 0),
    BoolOption("enableOptimize", "Compile with optimization", 0),
    BoolOption("enableDocs", "Build documentation", 0),
    BoolOption("enableTests", "Build tests", 0),
    # Enable or disable external packages.
    # These will also be listed in scons.cfg files, but if they are 
    # disabled here, that will override scons.cfg. Remark that unless the
    # module is listed as OptDependencies in scons.cfg, the whole module
    # will be turned off.
    BoolOption("cacheOptions", "Cache command-line options for later invocations", 1),
    BoolOption("veryClean", "Remove the sconsign file during clean, must be set during regular build", 0),
    ("customCxxFlags", "Customize compilation of C++ code", ""),
    ("customLinkFlags", "Customize linking of C++ code", ""),
    ("SSLOG", "Set Simula scons log file",
     pjoin(os.getcwd(), "scons", "simula_scons.log")),
    BoolOption("enableResolveCompiler", "Run tests to verify compiler", 1),
    ]


# This Configure class handles both command-line options (which are merged into 
# the environment) and autoconf-style tests. A special feature is that it
# remembers configuration parameters (options and results from tests) between
# invocations so that they are re-used when cleaning after a previous build.
configure = scons.Configure(env, ARGUMENTS, options)

# Open log file for writing
scons.logOpen(env)
scons.log("=================== %s log ===================" % env["projectname"])
scons.logDate()

# Writing the simula_scons used to the log:
scons.log("Using simula_scons from: %s" % scons.__file__)

# Notify the user about that options from scons/options.cache are being used:
if not env.GetOption("clean"):
  try:
    lines = file(pjoin('scons', 'options.cache')).readlines()
    if lines:
      print "Using options from scons/options.cache"
  except:
    pass

# If we are in very-clean mode, remove the sconsign file, the cached
# options file, and the generated pkgconfig files
if env.GetOption("clean"):
  try:
    if env["veryClean"]:
      os.unlink("%s.dblite" % syfi_sconsignfile)
      os.unlink(os.path.join('scons', 'options.cache'))
      import glob
      for f in glob.glob(os.path.join('scons', 'pkgconfig', '*.pc')):
        os.unlink(f)
  except OSError, msg:
    scons.log("Error using 'veryClean' option:\n%s\n" % msg)

# Default CXX and FORTRAN flags
env["CXXFLAGS"] = "-Wall -pipe -ansi" # -Werror"
#env["SHFORTRANFLAGS"] = "-Wall -pipe -fPIC"

# Default link flags
env["LINKFLAGS"] = ""

# If Debug is enabled, add -g:
if env["enableDebug"]:
  env.Append(CXXFLAGS=" -DDEBUG -g")

if not env["enableDebugUblas"]:
  env.Append(CXXFLAGS=" -DNDEBUG")

# if Optimization is requested, use -O3
if env["enableOptimize"]:
  env.Append(CXXFLAGS=" -O3")
else:
  # FIXME: why are we optimizing when enableOptimize is False?
  env.Append(CXXFLAGS=" -O2")

# Append whatever custom flags given
if env["customCxxFlags"]:
  env.Append(CXXFLAGS=" " + env["customCxxFlags"])

# Append custom linker flags
if env["customLinkFlags"]:
  env.Append(LINKFLAGS=" " + env["customLinkFlags"])

# Look for custom compiler and linker flags in os.environ
if os.environ.has_key("CXXFLAGS"):
  env.Append(CXXFLAGS=" %s" % os.environ["CXXFLAGS"])
if os.environ.has_key("LINKFLAGS"):
  env.Append(LINKFLAGS=" %s" % os.environ["LINKFLAGS"])

# Determine which compiler to be used:
cxx_compilers = ["c++", "g++", "CC"]
# Use CXX from os.environ if available:
env["CXX"] = os.environ.get("CXX", env.Detect(cxx_compilers))
if not env["CXX"]:
  print "Unable to find any valid C++ compiler."
  # try to use g++ as default:
  env["CXX"] = "g++"

# process list of packages to be included in allowed Dependencies.
# Do we need this any more? I think we rather pick up (external) packages from
# the scons.cfg files. Actually, I doubt usePackages is ever used?
#env["usePackages"] = scons.resolvePackages(env["usePackages"].split(','),\
#        env.get("customDefaultPackages", DefaultPackages).split(","))

# Figure out if we should fetch datafiles, and set an option in env. 
#doFetch = "fetch" in COMMAND_LINE_TARGETS or (env["autoFetch"]) and not env.GetOption("clean")
#env["doFetch"] = doFetch

# -----------------------------------------------------------------------------
# Call the main SConscript in the project directory
# -----------------------------------------------------------------------------
try:
    # Invoke the SConscript as if it was situated in the build directory, this
    # tells SCons to build beneath this
    buildDataHash = env.SConscript(pjoin(env["projectname"], "SConscript"),
                                   exports=["env", "configure"])
except PkgconfigError, err:
    sys.stderr.write("%s\n" % err)
    Exit(1)

# -----------------------------------------------------------------------------
# Set up build targets
# -----------------------------------------------------------------------------

# default build-targets: shared libs, extension modules, programs, demos, and
# documentation.
for n in buildDataHash["shlibs"] + buildDataHash["extModules"] + \
        buildDataHash["progs"], buildDataHash["docs"], buildDataHash["tests"]:
  env.Default(n)

# -----------------------------------------------------------------------------
# Set up installation targets
# -----------------------------------------------------------------------------

install_prefix = "$prefix"
if env.get("DESTDIR"):
  install_prefix = os.path.join("$DESTDIR", "$prefix")
binDir = env["binDir"].replace("$prefix", install_prefix)
includeDir = env["includeDir"].replace("$prefix", install_prefix)
libDir = env["libDir"].replace("$prefix", install_prefix)
pkgConfDir = env["pkgConfDir"].replace("$prefix", install_prefix)
pythonModuleDir = env["pythonModuleDir"].replace("$prefix", install_prefix)
pythonExtDir = env["pythonExtDir"].replace("$prefix", install_prefix)
manDir = env["manDir"].replace("$prefix", install_prefix)

# install sfc into binDir:
env.Install(binDir, pjoin("scripts", "sfc"))

# install sfc manual page into manDir/man1:
env.Install(os.path.join(manDir, "man1"),
            os.path.join("doc", "man", "man1", "sfc.1.gz"))

# shared libraries goes into our libDir:
for l in buildDataHash["shlibs"]:
    env.InstallVersionedSharedLibrary(libDir, l)

# install header files in includeDir/dolfin
for h in buildDataHash["headers"]:
    env.Install(pjoin(includeDir, "SyFi"), h)

# install python scripts in the bin directory
for s in buildDataHash["pythonScripts"]:
    env.Install(binDir, s)

# install python modules, usually in site-packages
for m in buildDataHash["pythonModules"]:
    env.Install(pythonModuleDir, m)

# install extension modules, usually in site-packages
for e in buildDataHash["extModules"]:
    env.Install(pythonExtDir, e)

# install SWIG interface files in includeDir/SyFi/swig
for s in buildDataHash["swigfiles"]:
    env.Install(pjoin(includeDir, "SyFi", "swig"), s)

# install generated pkg-config files in pkgConfDir/lib/pkgconfig
for p in buildDataHash["pkgconfig"]:
    env.Install(pkgConfDir, p)

# grab installation prefix, substitute all scons construction variables
# (those prefixed with $...), and create a normalized path:
prefix = os.path.normpath(env.subst(install_prefix))
# add '/' (or similar) at the end of prefix if missing:
if not prefix[-1] == os.path.sep:
  prefix += os.path.sep

installfiles = scons.buildFileList(buildDataHash["pythonPackageDirs"])
for f in installfiles:
    installpath=os.path.sep.join(os.path.dirname(f).split(os.path.sep)[1:])
    env.Install(pjoin(pythonModuleDir, installpath), f)

# install docs
_targetdir = pjoin(prefix, "share", "doc", env["projectname"])
if 'install' in COMMAND_LINE_TARGETS and not os.path.isdir(_targetdir):
    os.makedirs(_targetdir)

=== demo/Elements/cpp/Makefile ===

FLAGS=--integration-method=symbolic --debug=0
#FLAGS=--integration-method=quadrature

FORM=Elements

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=s2_2D.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/HyperElasticity1D/cpp/Makefile ===

FLAGS=--integration-method=quadrature --integration-order=9 --safemode=0

FORM=HyperElasticity1D

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &
	#paraview --data=usol.pvd &
	paraview --data=e.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/HyperElasticityMooneyRivlin/cpp/Makefile ===

#FLAGS=--integration-method=symbolic
FLAGS=--integration-method=quadrature --integration-order=5 --safemode=0

FORM=HyperElasticityMooneyRivlin

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/HyperElasticitySVK/cpp/Makefile ===

#FLAGS=--integration-method=symbolic
FLAGS=--integration-method=quadrature --integration-order=5 --safemode=0

FORM=HyperElasticitySVK

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/LinearElasticity/cpp/Makefile ===

FLAGS=--integration-method=symbolic
#FLAGS=--integration-method=quadrature --integration-order=3

FORM=LinearElasticity

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/Poisson1D/cpp/Makefile ===

FLAGS=--integration-method=symbolic
#FLAGS=--integration-method=quadrature --integration-order=3

FORM=Poisson1D

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/Poisson1D/cpp/SConstruct ===
# This is an example of a simple SConstruct file for building
# programs against DOLFIN. To build this demo, just type 'scons'.

import os, glob, commands

# Get compiler from pkg-config
compiler = commands.getoutput('pkg-config --variable=compiler dolfin')

# Create a SCons Environment based on the main os environment
env = Environment(ENV=os.environ, CXX=compiler)

# Get compiler flags from pkg-config
env.ParseConfig('pkg-config --cflags --libs dolfin')

# Generated code is not this robust (yet)
env.ParseConfig('echo -Wno-unused-variable')

# Program name
env.Program('demo', glob.glob("*.cpp") + glob.glob("generated_code/*.cpp"))

=== demo/Poisson2D/cpp/Makefile ===

FLAGS=--integration-method=symbolic
#FLAGS=--integration-method=quadrature --integration-order=15

FORM=Poisson

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/Poisson3D/cpp/Makefile ===

FLAGS=--integration-method=symbolic --debug=0
#FLAGS=--integration-method=quadrature --integration-order=3 --debug=0 --safemode=0

FORM=Poisson3D

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &
	#paraview --data=usol.pvd &
	#paraview --data=e.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/Projection/cpp/Makefile ===

FLAGS=--integration-method=symbolic
#FLAGS=--integration-method=quadrature --integration-order=3

FORM=Projection

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &
	paraview --data=f.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

=== demo/Projection1D/cpp/Makefile ===

FLAGS=--integration-method=symbolic
#FLAGS=--integration-method=quadrature --integration-order=9

FORM=Projection1D

demo: main.cpp generated_code/$(FORM).h
	scons -j3

generated_code/$(FORM).h: $(FORM).ufl
	sfc -w1 $(FLAGS) -ogenerated_code $(FORM).ufl

generate: clean demo

bench: $(FORM).ufl
	sfc -b1 $(FLAGS) $(FORM).ufl

view: run
	paraview --data=u.pvd &
	paraview --data=f.pvd &

run: demo
	rm -f *.pvd *.vtu
	./demo

debug: demo
	gdb ./demo

clean:
	rm -f *.pvd *.vtu
	rm -rf demo generated_code *.o 
	rm -f *.pyc

## syfi 0.6.2.dfsg

=== SConstruct ===
--- 
+++ 
@@ -24,7 +24,7 @@
 env["projectname"] = "syfi"
 
 # Set version
-env["SYFILIB_VERSION"] = "0.6.1"
+env["SYFILIB_VERSION"] = "0.6.2"
 
 def replace_lines(dotin_fname, replacements):
     f = file(dotin_fname)

## syfi 1.0

=== CMakeLists.txt ===
# Top level CMakeLists.txt file for SyFi

# Require CMake 2.8
cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
# Set project name and version number

project(SYFI)

set(SYFILIB_MAJOR_VERSION "1")
set(SYFILIB_MINOR_VERSION "0")
set(SYFILIB_MICRO_VERSION "0.beta")
set(SYFILIB_VERSION
  "${SYFILIB_MAJOR_VERSION}.${SYFILIB_MINOR_VERSION}.${SYFILIB_MICRO_VERSION}")
add_definitions(-DSYFILIB_VERSION="${SYFILIB_VERSION}")

#------------------------------------------------------------------------------
# General configuration

# Set CMake options, see `cmake --help-policy CMP000x`
if (COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0004 OLD)
endif()

# Set location of our FindFoo.cmake modules
set(CMAKE_MODULE_PATH 
  ${CMAKE_SOURCE_DIR}/cmake/modules
  ${CMAKE_MODULE_PATH})

# Make sure CMake uses the correct syfi-config.cmake for tests and demos
#set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/syfi)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

option(BUILD_SHARED_LIBS "Build SyFi with shared libraries." ON)
option(CMAKE_USE_RELATIVE_PATHS "Use relative paths in makefiles and projects." OFF)
option(SYFI_WITH_LIBRARY_VERSION "Build with library version information." ON)
option(SYFI_ENABLE_DOCS "Enable documentation." OFF)
option(SYFI_ENABLE_TESTING "Enable testing." OFF)

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  set(SYFI_CXX_DEVELOPER_FLAGS "-pipe ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag("-Wall -Werror" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  set(SYFI_CXX_DEVELOPER_FLAGS "-Wall -Werror ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag(-std=c++98 HAVE_STD)
if (HAVE_STD)
  set(SYFI_CXX_DEVELOPER_FLAGS "-std=c++98 ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  set(SYFI_CXX_DEVELOPER_FLAGS "-g ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

check_cxx_compiler_flag(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  set(SYFI_CXX_DEVELOPER_FLAGS "-O2 ${SYFI_CXX_DEVELOPER_FLAGS}")
endif()

# Set 'Developer' build type flags
set(CMAKE_CXX_FLAGS_DEVELOPER "${SYFI_CXX_DEVELOPER_FLAGS}" CACHE STRING
  "Flags used by the compiler during development." FORCE)

# Add debug definitions
if (CMAKE_BUILD_TYPE STREQUAL "Developer" OR CMAKE_BUILD_TYPE STREQUAL "Debug")
  list(APPEND SYFI_CXX_DEFINITIONS "-DDEBUG")
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

find_package(GiNaC REQUIRED)
find_package(PythonInterp REQUIRED)
find_package(PythonLibs REQUIRED)
find_package(NumPy REQUIRED)
find_package(SWIG REQUIRED)
include(UseSWIG)

#------------------------------------------------------------------------------
# Set include directories and libs of required packages

set(SYFI_INCLUDE_DIRECTORIES
  ${GINAC_INCLUDE_DIRS}
  ${PYTHON_INCLUDE_DIRS}
  ${NUMPY_INCLUDE_DIRS}
  )

set(SYFI_TARGET_LINK_LIBRARIES
  ${GINAC_LIBRARIES}
  )

#------------------------------------------------------------------------------
# Set compiler flags and include directories

# Add compiler include directories
include_directories(
  ${SYFI_SOURCE_DIR}/syfi
  ${SYFI_BINARY_DIR}/syfi
  ${SYFI_SOURCE_DIR}/syfi/swig
  ${SYFI_BINARY_DIR}/syfi/swig
  ${SYFI_INCLUDE_DIRECTORIES}
  )

# Add CXX defintions
add_definitions(${SYFI_CXX_DEFINITIONS})

# Add flags
set(CMAKE_CXX_FLAGS
  ${CMAKE_CXX_FLAGS}
  ${SYFI_CXX_FLAGS}
  )

#------------------------------------------------------------------------------
# Set SyFi install sub-directories

set(SYFI_BIN_DIR "bin" CACHE PATH "Binary installation directory.")
set(SYFI_LIB_DIR "lib" CACHE PATH "Library installation directory.")
set(SYFI_INCLUDE_DIR "include" CACHE PATH "C/C++ header installation directory.")
set(SYFI_PKGCONFIG_DIR "lib/pkgconfig" CACHE PATH "pkg-config file installation directory.")
set(SYFI_SHARE_DIR "share/syfi" CACHE PATH "Shared data installation directory.")
set(SYFI_MAN_DIR "share/man" CACHE PATH "Manual page installation directory.")

# Extract Python version info for use to determine where to install Python files
execute_process(
  COMMAND ${PYTHON_EXECUTABLE} -c "import platform; print platform.python_version()"
  OUTPUT_VARIABLE PYTHON_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
string(SUBSTRING "${PYTHON_VERSION}" 0 1 PYTHON_VERSION_MAJOR)
string(SUBSTRING "${PYTHON_VERSION}" 2 1 PYTHON_VERSION_MINOR)
string(SUBSTRING "${PYTHON_VERSION}" 4 1 PYTHON_VERSION_PATCH)

# We install Python files to lib/pythonX.Y/site-packages by default
set(SYFI_PYTHON_MODULE_DIR "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages"
  CACHE PATH "Python module installation directory")
set(SYFI_PYTHON_EXT_DIR "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages"
  CACHE PATH "Python extension module installation directory")

#------------------------------------------------------------------------------
# Installation of sfc

install(DIRECTORY ${CMAKE_SOURCE_DIR}/site-packages/sfc
  DESTINATION ${SYFI_PYTHON_MODULE_DIR}
  USE_SOURCE_PERMISSIONS
  COMPONENT RuntimeExecutables)

install(FILES ${CMAKE_SOURCE_DIR}/scripts/sfc
  DESTINATION ${SYFI_BIN_DIR}
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
  COMPONENT RuntimeExecutables)

#------------------------------------------------------------------------------
# Installation of SyFi manual pages

install(DIRECTORY ${SYFI_SOURCE_DIR}/doc/man/
  DESTINATION ${SYFI_MAN_DIR}
  USE_SOURCE_PERMISSIONS
  COMPONENT RuntimeExecutables)

#------------------------------------------------------------------------------
# SyFi library

# Add source directory
add_subdirectory(syfi)

#------------------------------------------------------------------------------
# Generate and install helper file syfi.conf

# FIXME: not cross-platform compatible
# Create and install syfi.conf file
configure_file(${CMAKE_SOURCE_DIR}/cmake/templates/syfi.conf.in
  ${CMAKE_BINARY_DIR}/syfi.conf @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/syfi.conf
  DESTINATION ${SYFI_SHARE_DIR}
  COMPONENT Development)

#------------------------------------------------------------------------------
# Add demos and install demo source files

# Copy demo files to build directory
file(COPY demo DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Add target "demo" for building the demos
add_custom_target(demo
  COMMAND ${PYTHON_EXECUTABLE} makeall.py
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/demo")

# Add target "demo_clean" for cleaning the demos
add_custom_target(demo_clean
  COMMAND ${PYTHON_EXECUTABLE} cleanall.py
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/demo")

# Install the demo source files
install(DIRECTORY demo DESTINATION ${SYFI_SHARE_DIR})

#------------------------------------------------------------------------------
# Install demo files

install(DIRECTORY demo DESTINATION ${SYFI_SHARE_DIR})

#------------------------------------------------------------------------------
# Add tests

if (SYFI_ENABLE_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()

#------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${SYFI_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_DEFINITIONS "${SYFI_CXX_DEFINITIONS}")

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${SYFI_TARGET_LINK_LIBRARIES})
  string(REGEX REPLACE "(.?:?/[^ ]*)/lib([^ ]*)\\.(a|so|dylib|dll)" "-L\\1 -l\\2"
    _linkflags
    "${_lib}"
    )

  # Only add libraries that matches the form -L<libdir> -l<lib>
  if ("${_linkflags}" MATCHES "-L.+ -l.+")
    set(PKG_LINKFLAGS "${_linkflags} ${PKG_LINKFLAGS}")
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
#set(PKG_LINK_FLAGS "${PKG_LINKFLAGS} ${SYFI_LINK_FLAGS}")

# Configure and install pkg-config file
configure_file(${SYFI_SOURCE_DIR}/cmake/templates/syfi.pc.in ${CMAKE_BINARY_DIR}/syfi.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/syfi.pc
  DESTINATION ${SYFI_PKGCONFIG_DIR}
  COMPONENT Development
  )

#------------------------------------------------------------------------------
# Add "make uninstall" target

configure_file(
  "${CMAKE_SOURCE_DIR}/cmake/templates/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== syfi/swig/CMakeLists.txt ===
# Set SWIG module name
set(SWIG_MODULE_NAME SyFi)

# Set SWIG flags
set(CMAKE_SWIG_FLAGS
  -module ${SWIG_MODULE_NAME}
  -shadow
  -modern
  -modernargs
  -fastdispatch
  -fvirtual
  -nosafecstrings
  -noproxydel
  -fastproxy
  -fastinit
  -fastunpack
  -fastquery
  -nobuildnone
  ${SYFI_CXX_DEFINITIONS}
  )
set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

# Get all SWIG interface files
file(GLOB SYFI_SWIG_INTERFACE_FILES "*.i")

# Set GiNaC version number in SWIG source file
string(REGEX REPLACE "([^ ])..?..?" "\\1" GINACLIB_MAJOR_VERSION "${GINAC_VERSION}")
string(REGEX REPLACE ".?.([^ ])..?" "\\1" GINACLIB_MINOR_VERSION "${GINAC_VERSION}")
string(REGEX REPLACE ".?..?.([^ ])" "\\1" GINACLIB_MICRO_VERSION "${GINAC_VERSION}")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/SyFi.i.in ${CMAKE_CURRENT_BINARY_DIR}/SyFi.i @ONLY)

# Set SWIG source file
set(SWIG_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/${SWIG_MODULE_NAME}.i)
set_source_files_properties(${SWIG_SOURCES} PROPERTIES CPLUSPLUS ON)

# Remove '-Werror' and '-Wall' flags (if present) when compiling SWIG-generated files
string(REGEX REPLACE "-Wall" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Wall" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")
string(REGEX REPLACE "-Werror" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
string(REGEX REPLACE "-Werror" " " CMAKE_CXX_FLAGS_DEVELOPER "${CMAKE_CXX_FLAGS_DEVELOPER}")

# The prevents swig being run unnecessarily
set_source_files_properties(${SWIG_SOURCES} PROPERTIES SWIG_MODULE_NAME ${SWIG_MODULE_NAME})

# Tell CMake which SWIG interface files should be checked for changes when recompile
set(SWIG_MODULE_${SWIG_MODULE_NAME}_EXTRA_DEPS
  ${SYFI_SWIG_INTERFACE_FILES}
  ${CMAKE_SOURCE_DIR}/syfi/SyFi.h
  )

swig_add_module(${SWIG_MODULE_NAME} python ${SWIG_SOURCES})
swig_link_libraries(${SWIG_MODULE_NAME} syfi ${SYFI_TARGET_LINK_LIBRARIES} ${PYTHON_LIBRARIES})

# Install Python .py files
get_target_property(SWIG_MODULE_LOCATION ${SWIG_MODULE_${SWIG_MODULE_NAME}_REAL_NAME} LOCATION)
install(FILES
  ${SWIG_MODULE_LOCATION} ${CMAKE_CURRENT_BINARY_DIR}/${SWIG_MODULE_NAME}.py
  DESTINATION ${SYFI_PYTHON_EXT_DIR}/
  COMPONENT RuntimeLibraries
  )

# Install SWIG interface files
install(FILES ${SYFI_SWIG_INTERFACE_FILES}
  DESTINATION ${SYFI_INCLUDE_DIR}/SyFi/swig
  COMPONENT Development
  )

## syfi 1.0-beta.dfsg

=== debian/changelog ===
syfi (1.0-beta.dfsg-2) unstable; urgency=low

  * Update short description for all packages (closes: #643600).
  * Add patch to fix "FTBFS against libginac2: error: =format-security:
    No such file or directory" (closes: #644044).

 -- Johannes Ring <johannr@simula.no>  Sun, 02 Oct 2011 18:14:26 +0200

syfi (1.0-beta.dfsg-1) unstable; urgency=low

  * New upstream release. This release adds support for GiNaC 1.6
    (closes: #628243).
  * Update Homepage field in debian/control and Maintainer field in
    debian/copyright.
  * Bump Standards-Version to 3.9.2 (no changes needed).
  * Move from python-central to dh_python2 (closes: #617116).
    - Remove python-central from Build-Depends.
    - Bump minimum required python-all-dev package version to 2.6.6-3~.
    - Remove XB-Python-Version line.
    - Bump minimum required cdbs version to 0.4.90~.
    - Replace XS-Python-Version with X-Python-Version.
    - Replace call to dh_pycentral with dh_python2 in debian/rules.
  * Build for all supported Python versions.
  * Rename binary package syfi-bin to sfc.
  * Rename binary package python-syfi0 to python-syfi.
  * Switch from SCons to CMake:
    - Replace scons with cmake in Build-Depends in debian/control.
    - Remove custom cdbs class for SCons.
    - Update debian/rules to build with CMake.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Update for new SOVERSION:
    - Rename debian/libsyfi0.install to debian/libsyfi1.0.install and
      debian/libsyfi0-dev.install to debian/libsyfi1.0-dev.install.
    - Replace libsyfi0 with libsyfi1.0 and libsyfi0-dev with
      libsyfi1.0-dev in debian/control. Update Conflicts, Replaces, and
      Provides as necessary.
  * Add lintian override syfi-dev: empty-binary-package.
  * Add patch for removing unnecessary include directories from
    pkgconfig file (syfi.pc) and CMake config file (syfi-config.cmake).
  * Use DEB_COMPRESS_EXCLUDE_ALL instead of deprecated
    DEB_COMPRESS_EXCLUDE in debian/rules.
  * Remove custom cdbs rules and licensecheck script for copyright check.
  * Update debian/copyright and debian/copyright_hints.

 -- Johannes Ring <johannr@simula.no>  Tue, 06 Sep 2011 14:41:46 +0200

syfi (0.6.2.dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #585360).
  * Package moved from pkg-scicomp to Debian Science.
  * Allow both .tgz and .tar.gz extensions in debian/watch.
  * Minor update in debian/copyright and debian/copyright_hints.

 -- Johannes Ring <johannr@simula.no>  Mon, 09 Aug 2010 16:10:50 +0200

syfi (0.6.1.dfsg-1) unstable; urgency=low

  * New upstream release.
  * debian/control:
    - Add DM-Upload-Allowed: yes.
    - Bump Standards-Version to 3.8.4.
    - Update description of all packages.
    - Add missing python-ufc to Depends for binary package syfi-bin.
  * debian/watch:
    - Update download URL.
    - Update for DFSG mangle.
  * debian/copyright: Update Maintainer and Source fields.
  * debian/rules: Remove get-hg-source target.
  * debian/{python-syfi0.install,syfi-bin.install}: Allow both
    site-packages and dist-packages.
  * Bump dh compat level to 7.
  * Remove debian/patches/ginac-1.5.patch since GiNaC 1.5 is now supported.
  * Add debian/README.source.

 -- Johannes Ring <johannr@simula.no>  Mon, 15 Feb 2010 13:42:46 +0100

syfi (0.6.0.dfsg-1) unstable; urgency=low

  * Initial release (Closes: #528633)

 -- Johannes Ring <johannr@simula.no>  Wed, 15 Oct 2008 13:19:28 +0200

=== debian/control ===
Source: syfi
Section: devel
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>, Johannes Ring <johannr@simula.no>
Build-Depends: cdbs (>= 0.4.90~),
 debhelper (>= 7),
 python-all-dev (>= 2.6.6-3~),
 cmake,
 swig,
 libginac-dev,
 pkg-config,
 python-numpy
Standards-Version: 3.9.2
X-Python-Version: >= 2.5
Homepage: http://www.fenicsproject.org
DM-Upload-Allowed: yes
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/syfi/trunk
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/syfi/trunk

Package: libsyfi1.0-dev
Section: libdevel
Architecture: any
Depends: swig,
 ufc,
 python-numpy,
 libsyfi1.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libsyfi0-dev
Replaces: libsyfi0-dev
Provides: libsyfi0-dev
Suggests: python-swiginac (>= 1.5.1)
Description: Finite element method (FEM) C++ library - development files
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the development files.

Package: syfi-dev
Section: libdevel
Architecture: all
Depends: libsyfi1.0-dev (>= ${source:Version}), ${misc:Depends}
Description: Empty package depending on latest SyFi development package
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package will always depend on the most recent version of libsyfiX-dev
 (X=version), so if you install it then you will get upgrades automatically.

Package: libsyfi1.0
Section: libs
Architecture: any
Conflicts: syfi
Replaces: syfi
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: syfi-doc, libsyfi1.0-dbg, python-syfi
Description: Finite element method (FEM) C++ library - shared libraries
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the shared libraries.

Package: libsyfi1.0-dbg
Section: debug
Architecture: any
Depends: libsyfi1.0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libsyfi0-dbg
Replaces: libsyfi0-dbg
Provides: libsyfi0-dbg
Description: Finite element method (FEM) C++ library - debugging libraries
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the shared libraries with debugging symbols.

Package: python-syfi
Section: python
Architecture: any
Depends: python-numpy,
 python-swiginac,
 libsyfi1.0 (= ${binary:Version}),
 ${python:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: python-syfi0, ${python:Provides}
Suggests: syfi-doc
Conflicts: python-syfi0
Replaces: python-syfi0
Description: Finite element method (FEM) C++ library - Python bindings
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains the Python interface for SyFi.

Package: syfi-doc
Architecture: all
Section: doc
Depends: libsyfi1.0-dev (>= ${source:Version}),
 sfc (= ${source:Version}),
 ${misc:Depends}
Description: Finite element method (FEM) C++ library - documentation
 The finite element method (FEM) package SyFi is a C++ library built on top of
 the symbolic math library GiNaC. The name SyFi stands for Symbolic Finite
 Elements. The package provides polygonal domains, polynomial spaces, and
 degrees of freedom as symbolic expressions that are easily manipulated. This
 makes it easy to define finite elements and variational forms. These elements
 and forms are then used to generate efficient C++ code.
 .
 SyFi is similar to FFC in the sense that it has a compiler that generates UFC
 code based on variational forms and finite elements. It is also similar to
 FIAT in the sense that it implements many different finite elements.
 .
 This package contains documentation and demo programs for SyFi.

Package: sfc
Architecture: all
Depends: python-ufl,
 python-numpy,
 python-ufc,
 python-syfi (>= ${source:Version}),
 ${python:Depends},
 ${misc:Depends}
Conflicts: syfi-bin
Replaces: syfi-bin
Provides: syfi-bin
Description: SyFi Form Compiler
 The SyFi Form Compiler (SFC) is a form compiler from the FEniCS
 project, compiling variational forms from the Unified Form Language
 (UFL) to efficient C++ implementations of Unified Form-assembly Code
 (UFC). SFC uses symbolic expressions for finite elements from SyFi.

=== debian/rules ===
#!/usr/bin/make -f

unexport CXXFLAGS
ifneq (,$(DEB_MAINTAINER_MODE))
  # Enable stuff not policy compliant (eg. unsuitable for build daemons)
  DEB_COPYRIGHT_CHECK_STRICT = yes
endif

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_COMPRESS_EXCLUDE_ALL := .py .cpp .h .pdf
DEB_INSTALL_DOCS_ALL += AUTHORS README TODO

DEB_CMAKE_EXTRA_FLAGS= \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D SWIG_EXECUTABLE:FILEPATH=/usr/bin/swig2.0 \
	..

USCAN_DESTDIR := $(CURDIR)

PY_VERSIONS = $(shell pyversions --requested debian/control | tac -s' ')

install-stamp-%:
	cd $(DEB_BUILDDIR) && rm CMakeCache.txt && \
	  cmake -D PYTHON_EXECUTABLE:FILEPATH=/usr/bin/$* \
	    -D PYTHON_LIBRARY:FILEPATH=/usr/lib/lib$*.so \
	    -D PYTHON_INCLUDE_DIR:PATH=/usr/include/$* \
	    $(DEB_CMAKE_NORMAL_ARGS) $(DEB_CMAKE_EXTRA_FLAGS)
	make -C $(DEB_BUILDDIR) install DESTDIR=$(CURDIR)/debian/tmp
	touch $@

install/python-syfi:: $(addprefix install-stamp-, $(PY_VERSIONS))

binary-install/python-syfi::
	dh_python2 -p$(cdbs_curpkg)

binary-install/sfc::
	dh_python2 -p$(cdbs_curpkg)

clean::
	-rm -rf $(addprefix install-stamp-, $(PY_VERSIONS))

DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/\.dfsg.*$$//p')

get-orig-source:
	set -ex ; \
	TMPDIR=`mktemp -d $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig.XXXXXX` ; \
	uscan --force-download --check-dirname-level 0 --destdir "$$TMPDIR" --download-version $(DEB_STRIPPED_UPSTREAM_VERSION) --upstream-version $(DEB_STRIPPED_UPSTREAM_VERSION); \
	tar -C "$$TMPDIR" --strip-components 1 -xzf "$$TMPDIR"/$(DEB_SOURCE_PACKAGE)_$(DEB_STRIPPED_UPSTREAM_VERSION).orig.tar.gz ; \
	rm -rf "$$TMPDIR"/doc/papers ; \
	rm -rf "$$TMPDIR"/doc/presentations ; \
	rm -f "$$TMPDIR"/etc/tables.txt ; \
	rm -f "$$TMPDIR"/$(DEB_SOURCE_PACKAGE)*.tar.gz ; \
	mv "$$TMPDIR" $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig ; \
	GZIP=-9 tar -czf $(CURDIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig ; \
	rm -rf $(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION).orig
